package parqueo;
import java.util.regex.Pattern;

public abstract class Vehiculo {

    public abstract int getTarifaPorHora();
    public abstract int getTarifaPorDia();
    public abstract String getNombre(); 

    private String placa;

    // Constructor
    public Vehiculo(String placa) {
        setPlaca(placa);
    }

    public String getPlaca() {
        return placa;
    }

    public void setPlaca(String placa) {
        if (esPlacaValida(placa)) {
            this.placa = placa;
        } else {
            throw new IllegalArgumentException("La placa debe tener el formato ABC123.");
        }
    }

    public static boolean esPlacaValida(String placa) {
        return Pattern.matches("[A-Z]{3}\\d{3}", placa);
    }


}
